// The Flock (a list of Boid objects)

class Flock {
  ArrayList<Boid> boids; // An ArrayList for all the boids
  ArrayList<Boid> antiGrav;
  ArrayList<PVector> antiGravPoints;
  drawableBoid fly;
  int nbrMax;
  boolean inverse;


  Flock(drawableBoid _fly, int _nbrMax) {
    boids = new ArrayList<Boid>(); // Initialize the ArrayList
    antiGrav = new ArrayList<Boid>();
    antiGravPoints = new ArrayList<PVector>();
    fly = _fly;
    nbrMax = _nbrMax;
    inverse = false;
  }


  void run() {
    for (Boid b : boids) {
      b.run(boids, antiGrav, antiGravPoints);  // Passing the entire list of boids to each boid individually
    }
  }

  void aligner() {
    for (Boid b : boids) {
      b.aligner();  // Passing the entire list of boids to each boid individually
    }
  }


  void addBoid(Boid b) {
    boids.add(b);
  }


  Boid chooseBoid(float freq) {
    Boid b = new Boid(random(width), random(height), fly, 4, 0.06);
    b.setCouleur(freq);
    if (inverse)
      b.invCouleur();
    addBoid(b);
    antiGrav.add(b);
    return b;
  } 


  void removeBoid(int ind) {
    antiGrav.remove(ind);
  }


  void invCouleur() {
    for (Boid b : boids)
      if (inverse)
        b.retourCouleur();
      else
        b.invCouleur();
    inverse = !inverse;
  }


  void removeGrav(int i) {antiGrav.remove(i);}
  void addGravPoints(PVector v) {antiGravPoints.add(v);}
  void removeGravPoints(int i) {antiGravPoints.remove(i);}
}

