import ddf.minim.*;
import ddf.minim.analysis.*;
final int NBR_NOTE = 10;
final float HAUTEUR_MIN = 60;
final float HAUTEUR_MAX = 180;
final float AMPL_MIN = 30;

class retourNote
{
  float hauteur;
  float amplitude;
  
  retourNote(float _hauteur, float _amplitude)
  {
    hauteur = _hauteur;
    amplitude = _amplitude;
  }
}


class readNotes
{
  Minim minim;
  AudioInput music;
  FFT fft;

  //variables pour écouter la note
  int countNoteDiff;
  float note;
  int countHMin;
  float[] tmpAmpl;
  float[] tmpSon;
  

  readNotes() {
    minim = new Minim(this);
    music = minim.getLineIn(Minim.MONO, 4096, 44100);
    fft = new FFT(music.mix.size(), 44100);
    
    countNoteDiff = 0;
    countHMin = 0;
    tmpAmpl = new float[NBR_NOTE];
    tmpSon = new float[NBR_NOTE];
  }


  void finalize() {
    music.close();
    minim.stop();
  }
  
  
  
  public retourNote analyse() {
    retourNote now = ecouter();
    if((abs(now.hauteur-note)/note > 0.1) || now.hauteur < HAUTEUR_MIN || now.amplitude < AMPL_MIN) {
      if(countNoteDiff >= NBR_NOTE) {
        if(countHMin > 3*NBR_NOTE/4) {
          now = elagage(tmpAmpl, tmpSon, NBR_NOTE);
          if(now.hauteur > HAUTEUR_MAX)
          now.hauteur = HAUTEUR_MAX;
          note = now.hauteur;
        }
        else {
          note = 1;
          now.hauteur = 1;
        }
        
        countNoteDiff = 0;
        countHMin = 0; 
        return now;
      }
      else {
        if(now.hauteur >= HAUTEUR_MIN && now.amplitude >= AMPL_MIN)
          countHMin++;
        tmpAmpl[countNoteDiff] = max(now.hauteur,HAUTEUR_MIN);
        tmpSon[countNoteDiff] = now.amplitude;
        countNoteDiff++;
      }
    }
    else {
      countNoteDiff = 0;
      countHMin = 0;
    }
    return null;
  }


  protected retourNote ecouter() {
    fft.forward( music.mix );
    float resBand=0;
    float res=0;
    float tmp;
    for (int i = 0; i < fft.specSize (); i++) {
      tmp = fft.getBand(i);
      if (tmp>resBand) {
        resBand = tmp;
        res = i;
      }
    }
    return new retourNote(res, resBand);
  } 
  
  
  protected retourNote elagage(float[] tableau, float[] amplitudes, int comptMax) {
    float moyenne = 0;
    for(int i=0; i<comptMax; i++)
      moyenne += tableau[i];
    moyenne /= comptMax;
    System.out.println(moyenne);
    
    int compt = 0;
    float moyenneBis = 0;
    float moyenneHauteur = 0;
    for(int i=0; i<comptMax; i++) {
      if(abs(tableau[i]-moyenne)/moyenne < 0.25) {
        moyenneBis += tableau[i];
        moyenneHauteur += amplitudes[i]; 
        tableau[compt] = tableau[i];
        amplitudes[compt] = amplitudes[i];
        compt++;
      }
    }
    for(int i=compt; i<comptMax; i++) {
      tableau[i] = 0;
      amplitudes[i] = 0;
    }
    moyenneBis /= compt;
    moyenneHauteur /= compt;
    
    System.out.println(moyenneBis);
    if(compt != comptMax)
      return elagage(tableau, amplitudes, compt);
    else
      return new retourNote(moyenneBis, moyenneHauteur);
  }
}
